fprintf (stdout, "Running a HYPHY-MPI test\n");

if (MPI_NODE_COUNT < 2)
{
	fprintf (stdout, "\nProgram launched in a single process environment\n");
}
else
{
	fprintf (stdout, "\nDetected ", MPI_NODE_COUNT, " computational nodes\n",
					 "Polling slave nodes...\n");
					 
	for (k=1; k<MPI_NODE_COUNT; k=k+1)
	{
		fprintf (stdout, "Polling node ", 1+k, "...\n");
		MPISend (k, "return 0;");
		MPIReceive (k,z,res);
		fprintf (stdout, "OK\n");
	}
	
	fprintf (stdout, "\nMeasuring simple job send/receieve throughput...\n");
	
	for (k=1; k<MPI_NODE_COUNT; k=k+1)
	{
		startTime = Time(1);
		mcount = 0;
		time_diff = 0;
		while (time_diff < 5)
		{
			MPISend (k, "return 0;");
			MPIReceive (k,z,res);
			mcount = mcount + 1;
			time_diff = Time(1)-startTime;
		}
		fprintf (stdout, "Node ", Format(k+1,5,0), " sent/received ", mcount/time_diff," batch jobs per second\n");
	}

	fprintf (stdout, "\nMeasuring relative computational performance...\n");
	
	testCommand = "logsum=0;startTime=Time(0);td=0;while(td<5){logsum=logsum+Log(lsi);lsi=lsi+1;td=Time(0)-startTime;};return lsi;";
	ExecuteCommands (testCommand);
	fprintf (stdout, "Master node reference index: ", Format (lsi,10,0), "\n");
	for (k=1; k<MPI_NODE_COUNT; k=k+1)
	{
		MPISend (k, testCommand);	
	}
	for (k=1; k<MPI_NODE_COUNT; k=k+1)
	{
		MPIReceive (k,z,res);
		res = 0+res;
		fprintf (stdout, "Slave node ", Format(k,3,0), " index: ", Format (res,10,0), ". ", Format (res*100/lsi,10,2), "% relative to the master\n");
	}
}