#include "TemplateModels/chooseGeneticCode.def";

SetDialogPrompt ("Please choose a codon data file:");

DataSet ds = ReadDataFile (PROMPT_FOR_FILE);
fprintf (stdout, "\n\nData Read:\n", ds);

if (IS_TREE_PRESENT_IN_DATA)
{
	fprintf (stdout, "\nTree In Data:", DATAFILE_TREE);
}

DataSetFilter	    all64 = CreateFilter (ds, 3, "", "");

stopCodonTemplate   = {1,64};

stopCodonTemplate   	= {1,64};
nonStopCodonTemplate	= {1,64};

for (stateCount=0; stateCount<64; stateCount=stateCount+1)
{
	if (_Genetic_Code[stateCount] == 10)
	{
		stopCodonTemplate[stateCount] = 1;
	}
	else
	{
		nonStopCodonTemplate[stateCount] = 1;
	}
}

sequenceNames = {all64.species, 1};

for (sequenceIndex = 0; sequenceIndex < all64.species; sequenceIndex = sequenceIndex+1)
{
	GetString (replacementString, all64, sequenceIndex);
	sequenceNames[sequenceIndex] = replacementString;
}

GetInformation (sequenceData, all64);
GetDataInfo    (duplicateMapper, all64);

replacementString = "---";
doSomething 	  = 0;

for (sequenceIndex = 0; sequenceIndex < all64.species; sequenceIndex = sequenceIndex+1)
{
	fprintf (stdout, "\nSequence ", sequenceNames[sequenceIndex], ":"); 
	stopCodonCount     = 0;
	sitesWithDeletions = {1,all64.unique_sites};
	
	for (siteIndex = 0; siteIndex < all64.unique_sites; siteIndex = siteIndex+1)
	{
		GetDataInfo (siteInfo, all64, sequenceIndex, siteIndex);
		siteInfo1 = stopCodonTemplate*siteInfo;
		siteInfo2 = nonStopCodonTemplate*siteInfo;
		if (siteInfo1[0]>0 && siteInfo2[0] == 0)
		{
			sitesWithDeletions[siteIndex] = 1;
			stopCodonCount 	= stopCodonCount+1;
		}
	}
	
	if (stopCodonCount > 0)
	{
		fprintf (stdout, " ", stopCodonCount, " stop codons found.");
		doSomething 		= 1;
		cleanedString 		= "";
		seqString 			= sequenceData[sequenceIndex];
		cleanedString 		* (Abs(seqString)+1);

		for (siteIndex = 0; siteIndex < all64.sites; siteIndex = siteIndex+1)
		{
			stopCodonCount = duplicateMapper[siteIndex];
			if (sitesWithDeletions[stopCodonCount])
			{
				cleanedString * replacementString;
			}
			else
			{
				cleanedString * seqString[3*siteIndex][3*siteIndex+2];
			}
		}
		cleanedString * 0;
		sequenceData[sequenceIndex] = cleanedString;
	}
	else
	{
		fprintf (stdout, " No stop codons found.");
	}
}

if (doSomething)
{
	SetDialogPrompt ("Save cleaned data to:");
	fprintf (PROMPT_FOR_FILE, CLEAR_FILE);
	for (sequenceIndex = 0; sequenceIndex < all64.species; sequenceIndex = sequenceIndex+1)
	{
		fprintf (LAST_FILE_PATH, "#", sequenceNames[sequenceIndex], "\n", sequenceData[sequenceIndex], "\n\n");
	}
}
else
{
	fprintf (stdout, "\n\nNo stop codons found\n\n");
}

sequenceData = 0;