incFileName = HYPHY_BASE_DIRECTORY+"TemplateBatchFiles"+DIRECTORY_SEPARATOR+"TemplateModels"+DIRECTORY_SEPARATOR+"chooseGeneticCode.def";
ExecuteCommands  ("#include \""+incFileName+"\";");

codonToAAMap = {};
codeToAA 	 = "FLIMVSPTAYXHQNKDECWRG";

nucChars = "ACGT";

for (p1=0; p1<64; p1=p1+1)
{
	codon = nucChars[p1$16]+nucChars[p1%16$4]+nucChars[p1%4];
	ccode = _Genetic_Code[p1];
	codonToAAMap[codon] = codeToAA[ccode];
}

SetDialogPrompt ("Please choose a data file to convert:");

ChoiceList (SKIP_OMISSIONS,"Deletions",1,SKIP_NONE,"Keep Deletions","Deletions will NOT be filtered from the data.",
			"Skip Deletions","Deletions will be pruned out and NOT included in the converted file.");


if (SKIP_OMISSIONS<0)
{
	fprintf (stdout, "\n\nExecution Canceled...");
}

DataSet        bigDataSet 		= ReadDataFile 	(PROMPT_FOR_FILE);
DataSetFilter  filteredData 	= CreateFilter	(bigDataSet,1);

GetInformation (theSequences,filteredData);

fprintf (stdout, "Read ", bigDataSet.species, " sequences with ", bigDataSet.sites, " sites.");

fprintf (stdout, "\nRead:\n", bigDataSet);

outSequences = "";
outSequences *  (bigDataSet.sites* bigDataSet.species);

for (seqCounter = 0; seqCounter < bigDataSet.species; seqCounter = seqCounter+1)
{
	
	aSeq = theSequences[seqCounter];
	seqLen = Abs(aSeq)-2;
	GetString (seqName, filteredData, seqCounter);
	translString = "";
	translString * (seqLen/3+1);
	for (seqPos = 0; seqPos < seqLen; seqPos = seqPos+3)
	{
		codon = aSeq[seqPos][seqPos+2];
		prot = codonToAAMap[codon];
		if (Abs(prot))
		{
			translString * prot;
		}
		else
		{
			translString * "?";
		}
	} 
	translString * 0;
	stopPos = translString||"X";
	if (stopPos[0]>=0)
	{
		stopCount = Rows(stopPos)$2;
		fprintf (stdout, "Warning: sequence ", seqName, " has ", stopCount, " stop codons.\n");  
	}	
	outSequences * (">" + seqName + "\n" + translString + "\n");
}

outSequences * 0;

DataSet        bigDataSet 		= ReadFromString   (outSequences);
DataSetFilter  filteredData 	= CreateFilter	   (bigDataSet,1);

DEFAULT_FILE_SAVE_NAME = LAST_FILE_PATH;
stopPos = DEFAULT_FILE_SAVE_NAME $ (DIRECTORY_SEPARATOR+"([^\\"+DIRECTORY_SEPARATOR+"]+)$");
if (stopPos [0] >= 0)
{
	stopPos = stopPos[2];
	DEFAULT_FILE_SAVE_NAME = DEFAULT_FILE_SAVE_NAME[stopPos][Abs(DEFAULT_FILE_SAVE_NAME)] + ".prot";
}

SetDialogPrompt ("Save translated file to:");
fprintf (PROMPT_FOR_FILE, CLEAR_FILE, filteredData);
