function computeCompartmentValues (part1, part2)
{
	resMatrix = {3,1};
	template1 = {ds.species, ds.species};
	template2 = {ds.species, ds.species};
	for (k=0; k<clASize;k=k+1)
	{
		idx1 = part1[k];
		for (k2=k+1; k2<clASize;k2=k2+1)
		{
			idx2 = part1[k2];
			template1 [idx1][idx2] = 1;
			template1 [idx2][idx1] = 1;
		}
	}

	for (k=0; k<clBSize;k=k+1)
	{
		idx1 = part2[k];
		for (k2=k+1; k2<clBSize;k2=k2+1)
		{
			idx2 = part2[k2];
			template2 [idx1][idx2] = 1;
			template2 [idx2][idx1] = 1;
		}
	}
	template3 = totalUnitSqr-template1-template2;
	
	count1 = totalUnitRow*(template1*totalUnitCol);
	count2 = totalUnitRow*(template2*totalUnitCol);
	count3 = totalUnitRow*(template3*totalUnitCol);
	
	sum1   = totalUnitRow*(template1$distanceMatrix*totalUnitCol);
	sum2   = totalUnitRow*(template2$distanceMatrix*totalUnitCol);
	sum3   = totalUnitRow*(template3$distanceMatrix*totalUnitCol);
	
	dd1 = sum1[0]/count1[0]*f_1^2+sum2[0]/count2[0]*f_2^2;
	
	resMatrix[2] = sum3[0]/(count3[0]-bothCladesSize);	/* pi_B */
	resMatrix[1] = dd1/(f_1^2+f_2^2);			        /* pi_S */
	resMatrix[0] = dd1 + 2*f_1*f_2*resMatrix[2];        /* pi_T */
	
	return    resMatrix;
}

/*------------------------------------------------------------------------------*/

ChoiceList (distanceChoice, "Distance Computation",1,SKIP_NONE,
			"Distance formulae","Use one of the predefined distance measures based on data comparisons. Fast.",
			"Full likelihood","Estimate distances using pairwise MLE. More choices but slow.",
			"Load Matrix","Re-load a previously computed matrix in HyPhy format");
			
if (distanceChoice < 0)
{
	return 0;
}

ChoiceList (dataType,"Data type",1,SKIP_NONE,"Nucleotide/Protein","Nucleotide or amino-acid (protein).",
				     "Codon","Codon (several available genetic codes).");

if (dataType<0) 
{
	return;
}

if (dataType)
{
	NICETY_LEVEL = 3;
	SetDialogPrompt ("Please choose a codon data file:");
	#include "TemplateModels/chooseGeneticCode.def";
}
else
{
	SetDialogPrompt ("Please choose a nucleotide or amino-acid data file:");
}


DataSet ds = ReadDataFile (PROMPT_FOR_FILE);

fprintf (stdout, "\nRead the following data:", ds,"\n\n");

promptFor2ndRegExp = 1;
#include "partitionSequences.ibf";
promptFor2ndRegExp = 0;

bothCladesSize = clASize + clBSize; 
f_1 = clASize/bothCladesSize;
f_2 = clBSize/bothCladesSize;

fprintf (stdout, "\nProportion of sequence in population 1: ", f_1,
				 "\nProportion of sequence in population 2: ", f_2, "\n");


p1vector = {};
p2vector = {};
overallSample2 = {1,bothCladesSize};
overallSample  = {};
sequencesIn	   = {};

for (specIndex = 0; specIndex < ds.species; specIndex = specIndex + 1)
{
	GetString (specName, ds, specIndex);
	
	if (cladeA[specName]>0)
	{
		p1vector			[Abs(p1vector)] 		= specIndex;
		overallSample2		[Abs(overallSample)] 	= 1;
		overallSample		[Abs(overallSample)] 	= specIndex;
		sequencesIn			[specIndex] 			= 1;
	}
	else
	{
		if (cladeB[specName]>0)
		{
			p2vector		[Abs(p2vector)] 		= specIndex;
			overallSample2	[Abs(overallSample)] 	= 2;
			overallSample	[Abs(overallSample)] 	= specIndex;
			sequencesIn		[specIndex] 			= 1;
		}
	}
}

if (dataType)
{
	DataSetFilter filteredData = CreateFilter (ds,3,"","",GeneticCodeExclusions);
}
else
{
	DataSetFilter filteredData = CreateFilter (ds,1,"","");
}

if (distanceChoice > 0)
{
	SelectTemplateModel(filteredData);
}

distanceMatrix = {ds.species, ds.species};

if (distanceChoice == 1)
{
	fprintf (stdout,"\nHYPHY is computing pairwise maximum likelihood distance estimates. A total of ", Format(ds.species*(ds.species-1)/2,0,0),
				    " estimations will be performed.\n");

	MESSAGE_LOGGING = 0;

	for (i = 0; i<ds.species-1; i=i+1)
	{
		for (j = 0; j<=i; j = j+1)
		{
			if (dataType)
			{
				DataSetFilter twoSpecFilter = CreateFilter (filteredData,3,"",(speciesIndex==i+1)||(speciesIndex==j),GeneticCodeExclusions);
			}
			else
			{
				DataSetFilter twoSpecFilter = CreateFilter (filteredData,1,"",(speciesIndex==i+1)||(speciesIndex==j));
			}
			if (FREQUENCY_SENSITIVE)
			{
				if (USE_POSITION_SPECIFIC_FREQS)
				{
					HarvestFrequencies (vectorOfFrequencies,filteredData,3,1,1);
				}
				else
				{
					HarvestFrequencies (vectorOfFrequencies,twoSpecFilter,1,1,0);
				}
			}
			if (FREQUENCY_SENSITIVE)
			{
				MULTIPLY_BY_FREQS = PopulateModelMatrix ("modelMatrix",vectorOfFrequencies);
				if (dataType)
				{
					codonFrequencies = BuildCodonFrequencies (vectorOfFrequencies);
					Model pairModel = (modelMatrix, codonFrequencies, MULTIPLY_BY_FREQS);
				}
				else
				{
					Model pairModel = (modelMatrix, vectorOfFrequencies, MULTIPLY_BY_FREQS);
				}
			}		
			else
			{
				if (i+j==0)
				{
					MULTIPLY_BY_FREQS = PopulateModelMatrix ("modelMatrix",equalFreqs);
					Model pairModel = (modelMatrix, equalFreqs, MULTIPLY_BY_FREQS);
				}
			}
			
			Tree Inferred_Tree = (1,2);
			LikelihoodFunction lf = (twoSpecFilter,Inferred_Tree);
			Optimize (res,lf);
			k = BranchLength (Inferred_Tree,0);
			distanceMatrix[j][i+1] = k;
			distanceMatrix[i+1][j] = k;
		}
	}
}
else
{
	if (distanceChoice == 2)
	{
		SetDialogPrompt ("Load the distance matrix");
		fscanf (PROMPT_FOR_FILE,"NMatrix",distanceMatrix);
		if ((Rows(distanceMatrix) != ds.species)||(Columns(distanceMatrix) != ds.species))
		{
			fprintf (stdout, "\nThe dimensions of the distance matrix are incompatible with the data set.\n");
			return  0;
		}		
	}
	else
	{
		DISTANCE_PROMPTS = 1;
		#include "chooseDistanceFormula.def";
		dummy = InitializeDistances (0);
					    
		tdc = 0;
		tdp = 0;
		ldp = 0;
		togo = ds.species*(ds.species-1)/2;

		fprintf (stdout,"\nHYPHY is computing pairwise distance estimates. A total of ", Format(togo,0,0),
					    " estimations will be performed.\n");
		
		for (i = 0; i<ds.species-1; i=i+1)
		{
			for (j = 0; j<=i; j = j+1)
			{
				k = ComputeDistanceFormula (i+1,j);
				distanceMatrix[j][i+1] = k;
				distanceMatrix[i+1][j] = k;
			}
			tdc = tdc+i+1;
			tdp = (tdc/togo * 100)$1;
			if (tdp>ldp)
			{
				ldp = tdp;
				fprintf (stdout, ldp, "% done\n");
			}
		}

		DISTANCE_PROMPTS = 0;
	}
}

/* make some unit matrices */

totalUnitRow = {1,ds.species};
totalUnitCol = {ds.species,1};
totalUnitSqr = {ds.species,ds.species};

for (k=0; k<ds.species; k=k+1)
{
	totalUnitRow[k] = 1;
	totalUnitCol[k] = 1;
	if (sequencesIn[k])
	{
		for (k2=0; k2<ds.species; k2=k2+1)
		{
			if (sequencesIn[k2])
			{
				totalUnitSqr [k][k2] = 1;
			}
		}
	}
}

resMx = computeCompartmentValues (p1vector,p2vector);
pi_D = resMx[2]-resMx[1];

F_ST_OBS = {{pi_D/(resMx[1]+pi_D),pi_D/(resMx[1]+resMx[2]),1-resMx[1]/resMx[0]}};

fprintf (stdout, "\n\nPopulation characterisitcs:",
				 "\nMetapopulation diversity (pi_T)       = ", resMx[0],
				 "\nMean subpopulation diversity (pi_S)   = ", resMx[1],
				 "\nMean interpopulation diversity (pi_B) = ", resMx[2],
				 "\n\nF_ST\n",
				 "\nHudson, Slatkin and Madison (Genetics     132:583-589): ",F_ST_OBS[0],
				 "\nSlatkin                     (Evolution    47:264-279) : ",F_ST_OBS[1],
				 "\nHudson, Boos and Kaplan	    (Mol Bio Evol 9: 138-151) : ",F_ST_OBS[2], "\n");
				 
F_ST_OBS = F_ST_OBS;
				 
ChoiceList (resample,"Permutation Test",1,SKIP_NONE,
					 "Skip","Do not perform a permutation test.",
				     "But of course","Randomly allocate sequences into subpopulations and tabulate the distribution of various F_ST statistics.");
				 

if (resample < 1)
{
	return 0;
}

sampleCount = 0;
while (sampleCount < 1)
{
	fprintf (stdout, "\nHow many permutations would you like to perform?");
	fscanf (stdin,"Number",sampleCount);
}

F_ST_1 = {sampleCount,2};
F_ST_2 = {sampleCount,2};
F_ST_3 = {sampleCount,2};
step   = sampleCount$20;

fprintf (stdout, "Running the simulations...\n");

for (sampleID = 0; sampleID < sampleCount; sampleID = sampleID + 1)
{
	aSample = Random(overallSample2,0);
	p1_1 	= {};
	p2_1 	= {};
	for (k=0; k<bothCladesSize;k=k+1)
	{
		k2 = overallSample[k];
		if (aSample[k] == 2)
		{
			p2_1[Abs(p2_1)] = k2;
		}
		else
		{
			p1_1[Abs(p1_1)] = k2;
		}
	}
	resMx = computeCompartmentValues (p1_1,p2_1);
	pi_D = resMx[2]-resMx[1];	
	F_ST_1[sampleID][1] = pi_D/(resMx[1]+pi_D);
	F_ST_2[sampleID][1] = pi_D/(resMx[1]+resMx[2]);
	F_ST_3[sampleID][1] = 1-resMx[1]/resMx[0];
	
	if ((sampleID+1)%step == 0)
	{
		fprintf (stdout, Format ((sampleID+1)*100/sampleCount, 6, 2), "% done\n");
	}
}

F_ST_1 = F_ST_1%1;
F_ST_2 = F_ST_2%1;
F_ST_3 = F_ST_3%1;

pv = {{sampleCount,sampleCount,sampleCount}};

for (sampleID = 0; sampleID < sampleCount; sampleID = sampleID + 1)
{
	step = sampleID/sampleCount;
	F_ST_1[sampleID][0] = step;
	F_ST_2[sampleID][0] = step;
	F_ST_3[sampleID][0] = step;
	if (pv[0]==sampleCount)
	{
		if (F_ST_1[sampleID][1] > F_ST_OBS[0])
		{
			pv[0] = sampleID;
		}
	}
	if (pv[1]==sampleCount)
	{
		if (F_ST_2[sampleID][1] > F_ST_OBS[1])
		{
			pv[1] = sampleID;
		}
	}
	if (pv[2]==sampleCount)
	{
		if (F_ST_3[sampleID][1] > F_ST_OBS[2])
		{
			pv[2] = sampleID;
		}
	}
}


fprintf (stdout, "\n\nProb {Random F_ST > Observed F_ST}\n",
				 "\nHudson, Slatkin and Madison : ",(sampleCount-pv[0])/sampleCount,
				 "\nSlatkin                     : ",(sampleCount-pv[1])/sampleCount,
				 "\nHudson, Boos and Kaplan	    : ",(sampleCount-pv[2])/sampleCount, "\n");


labels = {{"Cumulative Weight","F_ST"}};

OpenWindow (CHARTWINDOW,{{"Hudson, Slatkin and Madison F_ST"}
		{"labels"}
		{"F_ST_1"}
		{"Step Plot"}
		{"F_ST"}
		{"Cumulative Weight"}
		{"F_ST"}
		{""}
		{"Cumulative Probability"}
		{"3"}
		{""}
		{"-1;-1"}
		{"10;1.309;0.785398"}
		{"Times:14:0;Times:12:0;Times:14:1"}
		{"16777215;16777215;16512;11776947;0;16777215;16711680;11842740;13158600;14474460;0;3947580;79;16744448;16777215;2984993;9199669;7018159;1460610;16748822;11184810;14173291;14173291"}
		{"16"}
		},
		"SCREEN_WIDTH/2-50;SCREEN_HEIGHT/2-100;50;50");
		
OpenWindow (CHARTWINDOW,{{"Slatkin F_ST"}
		{"labels"}
		{"F_ST_2"}
		{"Step Plot"}
		{"F_ST"}
		{"Cumulative Weight"}
		{"F_ST"}
		{""}
		{"Cumulative Probability"}
		{"3"}
		{""}
		{"-1;-1"}
		{"10;1.309;0.785398"}
		{"Times:14:0;Times:12:0;Times:14:1"}
		{"16777215;16777215;16512;11776947;0;16777215;16711680;11842740;13158600;14474460;0;3947580;79;16744448;16777215;2984993;9199669;7018159;1460610;16748822;11184810;14173291;14173291"}
		{"16"}
		},
		"SCREEN_WIDTH/2-50;SCREEN_HEIGHT/2-100;50+SCREEN_WIDTH/2;50");

OpenWindow (CHARTWINDOW,{{"Hudson, Boos and Kaplan F_ST"}
		{"labels"}
		{"F_ST_3"}
		{"Step Plot"}
		{"F_ST"}
		{"Cumulative Weight"}
		{"F_ST"}
		{""}
		{"Cumulative Probability"}
		{"3"}
		{""}
		{"-1;-1"}
		{"10;1.309;0.785398"}
		{"Times:14:0;Times:12:0;Times:14:1"}
		{"16777215;16777215;16512;11776947;0;16777215;16711680;11842740;13158600;14474460;0;3947580;79;16744448;16777215;2984993;9199669;7018159;1460610;16748822;11184810;14173291;14173291"}
		{"16"}
		},
		"SCREEN_WIDTH/2-50;SCREEN_HEIGHT/2-100;50+SCREEN_WIDTH/2;100+SCREEN_HEIGHT/2");
