SetDialogPrompt("Select a nucleotide data file:");
DataSet myData = ReadDataFile (PROMPT_FOR_FILE);
DataSetFilter myFilter = CreateFilter (myData,1);
HarvestFrequencies (obsFreqs, myFilter, 1, 1, 1);
F81RateMatrix = 
                {{* ,mu,mu,mu}
                 {mu,* ,mu,mu}
                 {mu,mu,* ,mu}
                 {mu,mu,mu,* }};
Model F81 = (F81RateMatrix, obsFreqs);
Tree myTree = (a,b,og);

LikelihoodFunction theLikFun = (myFilter, myTree, obsFreqs);
Optimize (paramValues, theLikFun);
fprintf  (stdout, theLikFun);


BSRes = {{0.0,0.0,0.0,0.0}};
reps = 400;

fprintf (stdout,   "\n\n| Simul. # |   Ln lik    | Branch A | Branch B | Branch O |\n");
fprintf (stdout, "|----------|-------------|----------|----------|----------|\n");
Tree bsTree = (a,b,og);

fprintf(stdout,"|Observed  | ",Format(paramValues[1][0],11,3)," | ",
							   Format(paramValues[0][0],8,3)," | ",
							   Format(paramValues[0][1],8,3)," | ",
							   Format(paramValues[0][2],8,3)," | \n");
fprintf (stdout, "|----------|-------------|----------|----------|----------|\n");

for (simCounter = 1; simCounter<=reps; simCounter = simCounter+1)
{
	DataSetFilter simFilter = Bootstrap(myFilter,1);
	HarvestFrequencies (simFreqs, simFilter, 1, 1, 1);
	LikelihoodFunction simLik = (simFilter, bsTree, simFreqs);
	Optimize (simParamValues, simLik);
	fprintf (stdout, "|", Format(simCounter,10,0));
	fprintf (stdout,"| ", Format(simParamValues[1][0],11,3)," | ", 
						  Format(simParamValues[0][0],8,3)," | ",
						  Format(simParamValues[0][1],8,3)," | ",
						  Format(simParamValues[0][2],8,3)," | \n");
	BSRes[0] = BSRes[0] + simParamValues[1][0];
	BSRes[1] = BSRes[1] + simParamValues[0][0];
	BSRes[2] = BSRes[2] + simParamValues[0][1];
	BSRes[3] = BSRes[3] + simParamValues[0][2];
}

fprintf (stdout, "|----------|-------------|----------|----------|----------|\n");

fprintf(stdout,"|Averages: | ", Format(BSRes[0]/reps,11,3)," | ",
								Format(BSRes[1]/reps,8,3)," | ",
								Format(BSRes[2]/reps,8,3)," | ",
								Format(BSRes[3]/reps,8,3),"\n\n");
