OPTIMIZATION_PRECISION=0.0001;
OPTIMIZATION_PRECISION_METHOD=1;

LIKELIHOOD_FUNCTION_OUTPUT = 4;

SetDialogPrompt ("Please specify a nuleotide data file:");

DataSet myData  = ReadDataFile(PROMPT_FOR_FILE);
DataSetFilter myFilter = CreateFilter(myData,1);
HarvestFrequencies(obsFreqs,myFilter,1,1,1);

fprintf(stdout,"\n\n Original HKY85 Analysis  \n\n");
HKY85RateMatrix = {{*,b,a,b}{b,*,b,a}{a,b,*,b}{b,a,b,*}};
Model HKY85 = (HKY85RateMatrix, obsFreqs);
Tree myTree = ((a,b),c,og);
LikelihoodFunction theLikFun = (myFilter, myTree);
Optimize(results,theLikFun);
fprintf(stdout,theLikFun);

fprintf(stdout,"\n\n Local HKY85 Analysis  \n\n");
LocalHKY85Matrix = {{*,b,b*R,b}{b,*,b,b*R}{b*R,b,*,b}{b,b*R,b,*}};
Model LocalHKY85 = (LocalHKY85Matrix, obsFreqs);
Tree myTree = ((a,b),c,og);
LikelihoodFunction theLikFun = (myFilter, myTree);
Optimize(results,theLikFun);
fprintf(stdout,theLikFun);

fprintf(stdout,"\n\n Global HKY85 Analysis  \n\n");
global V=2.0; 
GlobalHKY85Matrix = {{*,b,b*V,b}{b,*,b,b*V}{b*V,b,*,b}{b,b*V,b,*}};
Model GlobalHKY85 = (GlobalHKY85Matrix, obsFreqs);
Tree myTree = ((a,b),c,og);
LikelihoodFunction theLikFun = (myFilter, myTree);
Optimize(results,theLikFun);
fprintf(stdout,theLikFun);
